.lf 1 tmac.an.nr
.\" This is -*-nroff-*-
.\" XXX standard disclaimer belongs here....
.\" /usr/local/devel/postgres-v4r2/src/ref/RCS/tmac.an.nr,v 1.2 1993/08/17 21:39:54 aoki Exp
.ds II INGRES
.ds PG POSTGRES
.ds UU UNIX
.ds PQ POSTQUEL
.ds LI LIBPQ
.ds PV 4.2
.de (l 			\" fake "-me"-style lists
.nf
.ie '\\$1'M' .in +0n
.el .in +5n
..
.de )l
.fi
.in
..
.de (C			\" constant-width font blocks
.(l \\$1
.sp
..
.de )C
.sp
.)l
..
.de BH			\" reference manual "big header" for sections
.SH NAME
\&\\$1
..
.de SB			\" section/index stuff
..	\" no-op
.de SE
..	\" no-op
.de XA
..	\" no-op
.de XP
..	\" no-op
.de SP
..
.ds lq ""
.ds rq ""
.lf 1 postquel/addattr.cmdsrc
.\" This is -*-nroff-*-
.\" XXX standard disclaimer belongs here....
.\" /usr/local/devel/postgres-v4r2/src/ref/postquel/RCS/addattr.cmdsrc,v 1.10 1994/02/09 10:33:12 aoki Exp
.TH ADDATTR COMMANDS 02/08/94
.XA 2 "Addattr"
.SH NAME
addattr \(em add attributes to a class
.SH SYNOPSIS
.(l M
\fBaddattr\fR \fB(\fR attname1 \fB=\fR type1 {\fB,\fR attname-i \fB=\fR type-i} \fB)\fR
	\fBto\fR classname [\fB*\fP]
.)l
.SH DESCRIPTION
The
.BR addattr
command
causes new attributes to be added to an existing class,
.IR classname .
The new attributes and their types are specified
in the same style and with the the same restrictions as in
.IR create (commands).
.PP
In order to add an attribute to each class in an entire inheritance
hierarchy, use the
.IR classname
of the superclass and append a \*(lq*\*(rq.  (By default, the
attribute will not be added to any of the subclasses.)  This should
.BR always
be done when adding an attribute to a superclass.  If it is not,
queries on the inheritance hierarchy such as
.(C
retrieve (s.all) from s in super*
.)C
will not work because the subclasses will be missing an attribute
found in the superclass.
.PP
For efficiency reasons, default values for added attributes are not
placed in existing instances of a class.  That is, existing instances
will have NULL values in the new attributes.  If non-NULL values are
desired, a subsequent
.IR replace (commands)
query should be run.
.PP
You must own the class in order to change its schema.
.SH EXAMPLE
.(C
/*
 * add the date of hire to the emp class
 */
addattr (hiredate = abstime) to emp
.)C
.(C
/*
 * add a health-care number to all persons
 * (including employees, students, ...)
 */
addattr (health_care_id = int4) to person*
.)C
.SH "SEE ALSO"
create(commands),
rename(commands),
replace(commands).
