.lf 1 tmac.an.nr
.\" This is -*-nroff-*-
.\" XXX standard disclaimer belongs here....
.\" /usr/local/devel/postgres-v4r2/src/ref/RCS/tmac.an.nr,v 1.2 1993/08/17 21:39:54 aoki Exp
.ds II INGRES
.ds PG POSTGRES
.ds UU UNIX
.ds PQ POSTQUEL
.ds LI LIBPQ
.ds PV 4.2
.de (l 			\" fake "-me"-style lists
.nf
.ie '\\$1'M' .in +0n
.el .in +5n
..
.de )l
.fi
.in
..
.de (C			\" constant-width font blocks
.(l \\$1
.sp
..
.de )C
.sp
.)l
..
.de BH			\" reference manual "big header" for sections
.SH NAME
\&\\$1
..
.de SB			\" section/index stuff
..	\" no-op
.de SE
..	\" no-op
.de XA
..	\" no-op
.de XP
..	\" no-op
.de SP
..
.ds lq ""
.ds rq ""
.lf 1 postquel/merge.cmdsrc
.\" This is -*-nroff-*-
.\" XXX standard disclaimer belongs here....
.\" /usr/local/devel/postgres-v4r2/src/ref/postquel/RCS/merge.cmdsrc,v 1.7 1994/03/12 11:08:20 aoki Exp
.TH MERGE COMMANDS 02/12/94
.XA 2 Merge
.SH NAME
merge \(em merge two classes
.SH SYNOPSIS
.(l M
\fBmerge\fR classname1 \fBinto\fR classname2
.)l
.SH DESCRIPTION
.BR Merge
will combine a version class, 
.IR classname1 ,
with its parent,
.IR classname2 .
If 
.IR classname2 
is a base class, then this operation merges a differently encoded
offset,
.IR classname1 ,
into its parent.  On the other hand, if 
.IR classname2 
is also a version, then this operation combines two differentially
encoded offsets together into a single one.  In either case any
children of
.IR classname1
become children of
.IR classname2 .
.PP
A version class may not be merged into its parent class when the 
parent class is also the parent of another version class.
.PP
However, merging in the reverse direction is allowed.
Specifically, merging the parent,
.IR classname1 ,
with a version,
.IR classname2 ,
causes
.IR classname2
to become disassociated from its parent.  As a side effect,
.IR classname1
will be destroyed if is not the parent of some other version class.
.SH EXAMPLE
.(C
/*
 * Combine office class and employee class
 */
merge office into employee
.)C
.SH "SEE ALSO"
create version(commands),
destroy(commands).
.SH BUGS
.BR Merge
is not implemented in Version \*(PV.
