.lf 1 tmac.an.nr
.\" This is -*-nroff-*-
.\" XXX standard disclaimer belongs here....
.\" /usr/local/devel/postgres-v4r2/src/ref/RCS/tmac.an.nr,v 1.2 1993/08/17 21:39:54 aoki Exp
.ds II INGRES
.ds PG POSTGRES
.ds UU UNIX
.ds PQ POSTQUEL
.ds LI LIBPQ
.ds PV 4.2
.de (l 			\" fake "-me"-style lists
.nf
.ie '\\$1'M' .in +0n
.el .in +5n
..
.de )l
.fi
.in
..
.de (C			\" constant-width font blocks
.(l \\$1
.sp
..
.de )C
.sp
.)l
..
.de BH			\" reference manual "big header" for sections
.SH NAME
\&\\$1
..
.de SB			\" section/index stuff
..	\" no-op
.de SE
..	\" no-op
.de XA
..	\" no-op
.de XP
..	\" no-op
.de SP
..
.ds lq ""
.ds rq ""
.lf 1 postquel/move.cmdsrc
.\" This is -*-nroff-*-
.\" XXX standard disclaimer belongs here....
.\" /usr/local/devel/postgres-v4r2/src/ref/postquel/RCS/move.cmdsrc,v 1.6 1994/03/12 11:09:03 aoki Exp
.TH MOVE COMMANDS 02/12/94
.XA 2 Move
.SH NAME
move \(em move the pointer in a portal
.SH SYNOPSIS
.(l M
\fBmove\fR [ ( \fBforward\fR | \fBbackward\fR ) ]
    [ ( number | \fBall\fR | \fBto\fR ( number | record_qual ) ) ]
    [ \fBin\fR portal_name ]
.)l
.SH DESCRIPTION
.BR Move
allows a user to move the
.IR "instance pointer"
within the portal named
.IR portal_name .
Each portal has an instance pointer, which points to the previous
instance to be fetched.  It always points to before the first instance
when the portal is first created.  The pointer can be moved
.IR forward
or
.IR backward .
It can be moved to an absolute position or over a certain distance.
An absolute position may be specified by using
.BR to ;
distance is specified by a number.
.IR Record_qual
is a qualification without instance variables, aggregates, or set
expressions which can be evaluated completely on a single instance in
the portal.
.SH EXAMPLE
.(C
/*
 * Move backwards 5 instances in the portal FOO
 */
move backward 5 in FOO
.)C
.(C
/*
 * Move to the 6th instance in the portal FOO
 */
move to 6 in FOO
.)C
.SH "SEE ALSO"
close(commands),
fetch(commands),
retrieve(commands).
.SH BUGS
.BR Move
is not implemented in Version \*(PV.  The portal pointer may be moved
using 
.IR fetch (commands)
and ignoring its return values.
